
//Fonty McFontface - a 7 bit ASCII pixel font class (monospaced/fixed width)
//dace.de 2022

//Usage (see also example below)
//  Fonty fonty = new Fonty();  //declare and construct the fonty object
//  fonty.vInit();  //to init everything
//  fonty.output("Hello", 10, 20);  //for output
//  fonty.height(18);  //for setting the height (the width is set automatically proportionally); it probably looks best when multiples of 9 are used for the height (the native resolution of the font is 9 pixels high)
//  fonty.height(0);  //reset height to native value
//  fonty.alignLeft();  //horizontal alignment, default
//  fonty.alignRight();
//  fonty.alignCenter();
//The text positioned as the default text, baseline left. Fonty uses the current fill colour.
//Bugs: Theoretically, Fonty should save the stroke weight, draw the font without outline, and restore the stroke weight to what was active before; that seems not to work.

Fonty fonty = new Fonty();

void setup()
{
  size(380, 140);
  background(20);

  fonty.vInit();

  fonty.output("Hello Fonty", 10, 20);
  fonty.alignRight();
  fonty.output("Hello Fonty, right-aligned", (width - 10), 20);
  fill(255, 200, 0);
  fonty.alignCenter();
  fonty.height(18);
  fonty.output("Hello Fonty 18, centred", (width * 0.5), 65);
  fill(0, 120, 0);
  fonty.alignLeft();
  fonty.height(36);
  fonty.output("Hello Fonty 36", 10, 120);
}

void draw()
{ }
